#include "usgard.h"
;
.org 0
.db	"Chating with the Ir_link",0
;
Depart:
	call CLEARTEXT
	res 1,(iy+13)
	call BUSY_OFF
	xor a
	ld (&txtuserl),a
	ld (&ligne),a
	ld (&nbrscroll),a
	inc a
	ld (&mode),a
	call CLEARLCD
	call &homeup
	call &newline
	ld hl,&Present1
	call D_ZT_STR
	call &newline
	ld hl,&Present2
	call D_ZT_STR
	call &newline
	ld hl,&Present3
	call D_ZT_STR
	ld de,$2112
	ld (CURSOR_X),de
	ld hl,&Present4
	call D_ZM_STR
	ld de,$385A
	ld (CURSOR_X),de
	ld hl,&Present5
	call D_ZM_STR
Keyloop:
	call GET_KEY
	or a
	jr z,Keyloop
	cp K_EXIT
	jp z,&Done
	call CLEARLCD
	call &homeup
	call &Affichecurseur
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
MainLoop:
	ld a,(&mode)
	cp 1
	jp z,&Text
	cp 2
	jp &Graph
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
Text:
	ld a,$C0
	out (7),a
	in a,(7)
	and 3
	cp 3
	jp nz,&Receive
	call GET_KEY
	or a
	jp z,&Text
	cp K_EXIT
	jp z,&Done
;	cp K_GRAPH
;	jp z,&LCDgraph			; pas encore operationnel
	cp K_DEL
	jp z,&DEL
	cp K_F5
	jp z,&sendtexte
	cp K_ENTER
	jp z,&Newline
	cp K_ALPHA
	jp z,&Alpha
	cp K_SECOND
	jp z,&Set0
	cp K_CLEAR
	jp z,&effaceLCD
	cp K_F1
	jp z,&ReponseBas
	cp K_F2
	jp z,&ReponseHaut
	call &CheckLetter
	cp 0
	jp z,&Text
	res 1,(iy+13)
	call TX_CHARPUT
	ld d,a
	ld hl,TEXT_MEM
	ld b,0
	ld a,(&txtuserl)
	ld c,a
	add hl,bc
	ld (hl),d
	ld hl,&txtuserl
	inc (hl)
	call &Affichecurseur
	ld a,(CURSOR_COL)
	cp 20
	jp nz,&Text
	ld d,$fe
	ld hl,TEXT_MEM
	ld b,0
	ld a,(&txtuserl)
	ld c,a
	add hl,bc
	ld (hl),d
	ld hl,&txtuserl
	inc (hl)
	ld a,(&ligne)
	cp 3
	jr z,Scrolldown
	ld hl,&ligne
	inc (hl)
	ld a,(CURSOR_ROW)
	cp 4
	jp nz,&Text
	ld hl,(&nbrscroll)
	inc (hl)
 	jp &Text
;
Newline:
	ld d,$fe
	ld hl,TEXT_MEM
	ld b,0
	ld a,(&txtuserl)
	ld c,a
	add hl,bc
	ld (hl),d
	ld hl,&txtuserl
	inc (hl)
	ld a,(&ligne)
	cp 3
	jr z,Scrolldown
	ld a,' '
	call &putmap
	call &newline
	ld hl,&ligne
	inc (hl)
	call &Affichecurseur
	jp &Text
;
Scrolldown:
	ld hl,&nbrscroll
	inc (hl)
	ld hl,$FC00
	call &Eff1demiLCD
	call &homeup
	ld hl,TEXT_MEM
	ld c,3
	xor a
	ld (CURSOR_ROW),a
	ld a,(&txtuserl)
	ld e,a
	ld a,(&nbrscroll)
	call &AfficheTxt
	xor a
	ld (CURSOR_COL),a
	ld a,3
	ld (CURSOR_ROW),a
	call &Affichecurseur
	jp &Text
;
effaceLCD:
	call &homeup
	ld hl,$FC00
	call &Eff1demiLCD
	xor a
	ld (&nbrscroll),a
	ld (&ligne),a
	ld (&txtuserl),a
	call &Affichecurseur
	jp &Text
;
DEL:
	ld a,(CURSOR_COL)
	cp 0
	jp z,&Text
	ld a,' '
	call &putmap
	ld hl,CURSOR_COL
	dec (hl)
	ld hl,&txtuserl
	dec (hl)
	call &Affichecurseur
	jp &Text
;
ReponseBas:
	ld a,(&Rnbrligne)
	ld b,a
	ld a,(&RnbrScroll)
	add a,4
	cp b
	jp nc,&Text
	sub 3
	ld (&RnbrScroll),a
	ld hl,$FE00
	call &Eff1demiLCD
	ld hl,(CURSOR_ROW)
	push hl
	ld hl,TEXT_MEM2
	ld c,4
	ld a,4
	ld (CURSOR_ROW),a
	ld a,(&reponsel)
	ld e,a
	ld a,(&RnbrScroll)
	jr RSuite
ReponseHaut:
	ld a,(&RnbrScroll)
	cp 0
	jp z,&Text
	dec a
	ld (&RnbrScroll),a
	ld hl,$FE00
	call &Eff1demiLCD
	ld hl,(CURSOR_ROW)
	push hl
	ld hl,TEXT_MEM2
	ld c,4
	ld a,4
	ld (CURSOR_ROW),a
	ld a,(&reponsel)
	ld e,a
	ld a,(&RnbrScroll)
RSuite:
	call &AfficheTxt
	pop hl
	ld (CURSOR_ROW),hl
	call &Affichecurseur
	jp &Text
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
Graph1
	call GCurseur
Graph:
	ld a, $C0
	out (7), a
	in a, (7)
	and 3
	cp 3
	jp nz, Receive
	call GET_KEY
	or a
	jp z, Graph
	cp K_EXIT
	jp z, Done
	cp K_GRAPH
	jp z, LCDmain
	cp K_LEFT
	jp z, agauche
	cp K_RIGHT
	jp z, adroite
	cp K_UP
	jp z, enhaut
	cp K_DOWN
	jp z, enbas
	cp K_SECOND
	jp z, Line
	jp Graph
;
Line:
	ld a, (pt1y)
	cp 0
	jp nz, deuxiemepoint
premierpoint:
	ld a, (curX)
	ld (pt1x), a
	ld b, a
	ld a, (curY)
	ld (pt1y), a
	ld c, a
	ld d, 1
	call IPoint
	jp Graph1
deuxiemepoint:
	ld a, (curX)
	ld (pt2x), a
	ld d, a
	ld a, (curY)
	ld (pt2y), a
	ld e, a
	ld a, (pt1x)
	ld h, a
	ld a, (pt1y)
	ld l, a
;	#fncall FLINE
	call sendline
	xor a
	ld (pt1x), a
	ld (pt2x), a
	ld (pt1y), a
	ld (pt2y), a
	jp Graph
GCurseur:
	ld  hl, GRAPH_MEM
	ld  de, $fc00
	ld  bc, 1024
	ldir
	set 1, (iy+2)
	ld a, (curX)
	ld b, a
	ld d, a
	ld a, (curY)
	ld c, a
	ld e, a
	dec e
	dec e
	ld a, -1
	cp e
	jp nz, GCok1
	ld e, 0
GCok1
	inc c
	inc c
	ex de, hl
;	#fncall FLINE
	ld a, (curX)
	ld b, a
	ld d, a
	ld a, (curY)
	ld c, a
	ld e, a
	dec b
	dec b
	ld a, (curX)
	or 1
	cp 1
	jp nz, GCok2
	ld b, 0
GCok2
	inc d
	inc d
	ex de, hl
;	#fncall FLINE		
	ld a, (curX)
	ld b, a
	ld a, (curY)
	ld c, a
	ld d, 2
	call IPoint
	res 1, (iy+2)
	ret
agauche:
	ld a, (curX)
	or a
	jp z, Graph
	ld hl, curX
	dec (hl)
	jp Graph1
adroite:
	ld a, (curX)
	cp 126
	jp z, Graph
	ld hl, curX
	inc (hl)
	jp Graph1
enbas:
	ld a, (curY)
	cp 1
	jp z, Graph
	ld hl, curY
	dec (hl)
	jp Graph1
enhaut:
	ld a, (curY)
	cp 63
	jp z, Graph
	ld hl, curY
	inc (hl)
	jp Graph1
;---------------------------------------------------------------------
;Affiche une chaine de caracteres
;---------------------------------------------------------------------
AfficheTxt:
	res 1,(iy+13)
	res 2,(iy+5)
	res 2,(iy+13)
	ld b,a
	cp 0
	jr z,endbtdetxt
	ld a,$FE
ATloop1:
	cp (hl)
	inc hl
	jr nz,ATloop1
	djnz ATloop1
endbtdetxt:
	xor a
	ld (CURSOR_COL),a
	ld b,c
	ld d,0
	inc e
ATloop2:
	dec e
	ld a,e
	cp 0
	ret z
	ld a,(hl)
	inc hl
	cp $FE
	jr z,alaligne
	call TX_CHARPUT
	inc d
	ld a,21
	cp d
	jr nz,ATloop2
	xor a
	ld d,a
	cp b
	ret z
	jr ATloop2
alaligne:
	call &newline
	djnz ATloop2
	ret
;---------------------------------------------------------------------
; affiche le curseur et la ligne horizontale
;---------------------------------------------------------------------
Affichecurseur:
	res 1,(iy+13)
	ld a,(&curseur)
	call &putmap
	ld hl,$FDF0
	ld b,16
Cloop:
	ld (hl),$FF
	inc hl
	djnz Cloop
	ret
;---------------------------------------------------------------------
; Efface 1/2 cran
;---------------------------------------------------------------------
Eff1demiLCD:
	ld bc,$01F0
effLoop:
	ld (hl),0
	inc hl
	dec bc
	ld a,b
	or c
	jr nz,effLoop
	ret
;---------------------------------------------------------------------
; changement d'cran
;---------------------------------------------------------------------
LCDmain:
	call &ecranprincipal
	jp &Text
LCDgraph:
	call &ecrangraph
	jp &Graph
ecrangraph:
	ld a,2
	ld (&mode),a
	ld a,' '
	call &putmap
	ld  hl,GRAPH_MEM
	ld  de,$fc00
	ld  bc,1024
	ldir
	call &GCurseur
	ret
ecranprincipal:
	ld a,1
	ld (&mode),a
	call CLEARLCD
	ld hl,TEXT_MEM
	ld c,4
	xor a
	ld (CURSOR_ROW),a
	ld a,(&txtuserl)
	ld e,a
	ld a,(&nbrscroll)
	call &AfficheTxt
	ld hl,(CURSOR_ROW)
	push hl
	ld hl,TEXT_MEM2
	ld c,4
	ld a,3
	ld (CURSOR_ROW),a
	ld a,(&reponsel)
	ld e,a
	ld a,0
	call &AfficheTxt
	pop hl
	ld (CURSOR_ROW),hl
	call &Affichecurseur
	ret
;---------------------------------------------------------------------
; changement de lettres (maj,  min,  spciales)
;---------------------------------------------------------------------
Alpha:
	ld a,(&curseur)
	cp 225
	jr z,seta
setA:
	ld a,225
	jr Asuite
seta:
	ld a,226
	jr Asuite
Set0:
	ld a,223
Asuite:
	ld (&curseur),a
	ld a,(&mode)
	cp 1
	call z,&Affichecurseur
	jp &MainLoop
;---------------------------------------------------------------------
; recherche de la lettre correspondant  la touche presse
;---------------------------------------------------------------------
CheckLetter:
	ld b,a
	ld a,(&curseur)
	cp 226
	jr z,alpha
	cp 223
	jr z,norm
	ld a,b
	jr CLsuite
alpha:
	ld a,$40
	add a,b
	jr CLsuite
norm:
	ld a,$80
	add a,b
CLsuite:
	ld bc,$0048
	ld hl,&Touches
	cpir
	ld a,c
	ret nz
	ld hl,&Lettres
	add hl,bc
	ld a,(hl)
	ret
;---------------------------------------------------------------------
; envoyer quelque chose
;---------------------------------------------------------------------
sendtexte:
	ld a,(&txtuserl)
	or a
	jp z,&MainLoop
	ld b,a
	ld a,' '
	call &putmap
	ld a,$F8
	call &PutByte
	jr nz,ilnyapasdePIC
	ld a,$F2
	call &PutByte
	ld a,$FB
	call &PutByte
	ld a,b
	call &PutByte
	ld hl,TEXT_MEM
	call &Sendcaractere
	jr FinLiaison
sendline:
	ld a,$F8
	call &PutByte
	jr nz,ilnyapasdePIC
	ld a,$F0
	call &PutByte
	ld a,$FB
	call &PutByte
	ld a,4
	call &PutByte
	ld b,4
	ld hl,&pt1x
	call &Sendcaractere
	call &FinLiaison
	ret
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
FinLiaison:
	ld a,$F9
	call &PutByte
	ld bc,$FFFF
reponse:
	in a,(7)
	and 3
	cp 3
	jr nz,Ssuite

	dec bc
	ld a,b
	or c
	jr nz,reponse
	jr erreurinsend
Ssuite:
	call &GetByte
	cp $F6
	jr nz,erreurinsend
;pas d'erreur:
	ld a,(&mode)
	cp 1
	jp z,&effaceLCD
	ret
ilnyapasdePIC:
	ld de,&SendWrong1
	jr Message
erreurinsend:
	ld de,&SendWrong2
;	jr Message
Message:
	res 2,(iy+12)
	push de
	call CLEARLCD
	pop hl
	ld de,0
	ld (CURSOR_ROW),de
	call D_ZT_STR
Mloop:
	call GET_KEY
	or a
	jr z,Mloop
	ld a,(&mode)
	cp 1
	jr z,affprincipal
	jp &ecrangraph
affprincipal:
	jp &LCDmain
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
Sendcaractere:
	ld a,(hl)
	call &PutByte
	inc hl
	djnz Sendcaractere
	ret
;---------------------------------------------------------------------
; Thanks for Sami Khawam (sKhawam@bigfoot.com) for his send routine.
;---------------------------------------------------------------------
PutByte:
	call BUSY_ON
	push bc
	ld c,a
	ld b,8						; 8 Bits
PBNextBit:
	ld a,$C0
	out (7),a
Cont:
	rr c
	jr nc,PBSendZero
PBSendOne:
	ld a,$E8
	jr PBOutputval
PBSendZero:
	ld      a,$D4
PBOutputval:
	out (7),a
	ld de,$FFFF					; For time-out
PBWaitforW0andR0:
	in a,(7)
	and 3
	jr Z,PBContinue
	in a,(7)
	and 3
	jr Z,PBContinue
	dec de
	ld a,d
	or e
	jr nz,PBWaitforW0andR0
	or 3
	jr PBEnd					; If error return.
PBContinue:
	ld a,$C0
	out (7),a
	ld de,$FFFF					; Reload time-out
PBWaitforW1andR1:
	dec de
	ld a,d
	or e
	jr z,PBEnd
	in a,(7)
	and 3
	cp 3
	jr nz,PBWaitforW1andR1
	djnz PBNextBit
	ld de,$06FF					; Small delay
PBEW:  
	dec de
	ld a,d
	or e
	jr nz,PBEW
PBEnd:
	pop bc
	call BUSY_OFF
	ret
SendWrong2:
 .db	"                     "
 .db	"  ****************** "
 .db	"  *  transmission  * "
 .db	"  *     failed     * "
 .db	"  *                * "
 .db	"  * (not received) * "
 .db	"  ****************** "
 .db	"                    ", 0
SendWrong1:
 .db	"                     "
 .db	"  *****************  "
 .db	"  *  transmission *  "
 .db	"  *     failed    *  "
 .db	"  *   (PIC not    *  "
 .db	"  *   connected)  *  "
 .db	"  *****************  "
 .db	"                    ", 0
;---------------------------------------------------------------------
; recevoir quelque chose
;---------------------------------------------------------------------
Receive:
	call &GetByte
	or a
	jp z,&MainLoop
	call &GetByte
	cp $F0
	jp z,&Receiveline
;	cp $F1
;	jp z,&ReceivetexteG
	cp $F2
	jp z,&Receivetexte
	jp &MainLoop
;
Receivetexte:
	ld a,(&mode)
	cp 1
	call nz,&ecranprincipal
	call &GetByte
	call &GetByte
	ld c,a
	ld b,0
	ld hl,&Rnbrligne
	ld (hl),1
	ld hl,TEXT_MEM2
ReceiveTLoop:
	push hl
	call &GetByte
	pop hl
	cp $F9
	jr z,Rsuite
	cp $FE
	call z,&entreplus1
	inc b
	ld (hl),a
	inc hl
	jr ReceiveTLoop
Rsuite:
	ld a,b
	cp c
	jr z,RTsok
	xor a
	call &PutByte
	jp &MainLoop
RTsok:
	ld (hl),$FE
	push bc
	ld a,$F6
	call &PutByte
	pop bc
	ld a,b
	ld (&reponsel), a
	ld hl,(CURSOR_ROW)
	push hl
	ld hl,$FE00
	call &Eff1demiLCD
	xor a
	ld (&RnbrScroll),a
	ld a,4
	ld (CURSOR_ROW),a
	ld hl,TEXT_MEM2
	ld c,4
	ld a,(&reponsel)
	ld e,a
	ld a,(&RnbrScroll)
	call &AfficheTxt
	pop hl
	ld (CURSOR_ROW),hl
	call &Affichecurseur
	jp &MainLoop
entreplus1:
	push hl
	ld hl,&Rnbrligne
	inc (hl)
	pop hl
	ret
;
Receiveline:
	ld a,(&mode)
	cp 2
	call nz,ecrangraph
	call &GetByte
;	cp $FA
;	jr z,froma8283
;	cp $FB
;	jr z, froma8586
;	cp $FC
;	jr z, froma92
;	cp $FD
;	jr z, froma89
;
	call &GetByte
	ld c,a
	ld hl,&ptR
	ld b,0
ReceiveLLoop:
	call &GetByte
	cp $F9
	jp z,&RLsuite
	inc b
	ld (hl),a
	inc hl
	jr ReceiveLLoop
RLsuite:
	ld a,b
	cp c
	jr z,RLok
	xor a
	call &PutByte
	jp &Graph
RLok:
	ld a,$F6
	call &PutByte
	ld hl,&ptR
	ld d,(hl)
	inc hl
	ld e,(hl)
	inc hl
	ld b,(hl)
	inc hl
	ld c,(hl)
	ex de,hl
;	#fncall FLINE
	jp &Graph
;---------------------------------------------------------------------
; Thanks for Randy Gluvna (&gluvna@home.com) for this recieve routine.
;---------------------------------------------------------------------
GetByte:
	push bc
	ld b, 008H
R0:
	ld de, 0FFFFH
	jr R2
R1:
	in  a, (7)
	and 003H
	jr z, GBEnd
	cp 003H
	jr nz, R3
	in A, (7)
	and 003H
	jr z, GBEnd
	cp 003H
	jr nz, R3
R2:
	dec de
	ld a, d
	or e
	jr nz, R1
	jr GBEnd
R3:
	sub 002H
	jr nc, R8
	ld a, 0D4H
	out (7), a
	rr c
	ld de, 0FFFFH
R4:
	in a, (7)
	and 003H
	cp 002h
	jr z, R5
	dec de
	ld a, d
	or e
	jr nz, R4
	jr GBEnd
R5:
	ld a, 0C0H
	out (7), a
	ld D, 004H
R6:
	dec d
	jr z, R7
	in a, (7)
	and 003H
	cp 003H
	jr nz, R6
R7:
	djnz R0
	ld a, c
	jr GBEnd
R8:
	ld a, 0E8H
	out (7), a
	rr c
	ld de, 0FFFFh
R9:
	in a, (7)
	and 003H
	cp 001H
	jr z, R5
	dec de
	ld a, d
	or e
	jr nz, R9
GBEnd
	pop bc
	ret
;---------------------------------------------------------------------
; fin du programme
;---------------------------------------------------------------------
Done:
	set 1,(iy+13)
	set 2,(iy+5)
	set 2,(iy+13)
	call CLEARLCD
	call &homeup
	ret
;---------------------------------------------------------------------
; routines pour la 85
;---------------------------------------------------------------------
newline:
	push hl
	ld hl,CURSOR_ROW
	inc (hl)
	ld hl,CURSOR_COL
	ld (hl),0
	pop hl
	ret
homeup:
	ld hl,0
	ld (CURSOR_ROW),hl
	ret
putmap:
	ld hl,(CURSOR_ROW)
	push hl
	call TX_CHARPUT
	pop hl
	ld (CURSOR_ROW), hl
	ret
;
IPoint:
	ld a, d
	cp 0
	jr z, Blanc
	cp 1
	jr z, Noir
Blanc:
	call FIND_PIXEL
	ld de, $FC00
	add hl, de
	cpl
	and (hl)
	ld (hl), a
	ret
Noir:
	call FIND_PIXEL
	ld de, $FC00
	add hl, de
	or (hl)
	ld (hl), a
	ret
;
;*********************************************************************
curX:		.db 63
curY:		.db 32
pt1x:		.db 0
pt1y:		.db 0
pt2x:		.db 0
pt2y:		.db 0
ptR:		.db 0,0,0,0
mode:		.db 1
txtuserl:	.db 0
curseur:	.db 223
ligne:		.db 0
nbrscroll:	.db 0
reponsel:	.db 0
RnbrScroll:	.db 0
Rnbrligne:	.db 0
Touches:
 .db	$8E,$95,$9D,$AB,$8D,$8C,$8B,$8A,$94,$9C,$A4,$93,$9B,$A3,$92
 .db	$9A,$A2,$A1,$11,$19,$21,$0A,$12,$1A,$22,$0B,$13,$1B,$23,$2B
 .db	$0C,$14,$1C,$24,$2C,$0D,$15,$1D,$25,$2D,$0E,$16,$1E,$26,$2E
 .db	$51,$59,$61,$4A,$52,$5A,$62,$4B,$53,$5B,$63,$6B,$4C,$54,$5C
 .db	$64,$6C,$4D,$55,$5D,$65,$6D,$4E,$56,$5E,$66,$6E
Lettres:
 .db	"abcdefghijklmnopqrstuvwxyz "
 .db	"ABCDEFGHIJKLMNOPQRSTUVWXYZ "
 .db	"0123456789+-*/, (&)^"
Present1: .db	"     IrTerm v1.0",0
Present2: .db	"         by",0
Present3: .db	"   Antoine MERCIER",0
Present4: .db	"jfmercier@univ-lemans.fr",0
Present5: .db	"press a key",0
.end
